#include <stdio.h>

int main() {
	    /*
	     * Anlegen eines initialisierten Arrays
	     * (der Compiler bestimmt in diesem Fall die Groesse)
	     */
	int a[] = {1, 2, 3, 4, 5};
	int i;

	    /*
	     * Zugriff auf die Array-Elemente und Ausgabe
	     */
	for (i = 0; i < 5; i++)
		printf("a[%d] = %d\n", i, a[i]);

	    /*
	     * Zugriff auf ein Element, das sicher ausserhalb
	     * des Speicherbereichs liegt, der dem Prozess
	     * zugeteilt wurde
	     * => segmentation fault/violation => core dump
	     */
	a[10000]++;

	return 0;
}
