#include <stdio.h>

int main() {
	int a[] = {1, 2, 3, 4, 5};
	int i, len;
	int *p = a;

	printf("sizeof(a) = %d\n", sizeof(a));
	printf("sizeof(a[0]) = %d\n", sizeof(a[0]));

	    /*
	     * auf folgende Art kann man die Anzahl der
	     * Elemente eines Arrays ermitteln:
	     */
	len = sizeof(a) / sizeof(a[0]);

	printf("len = %d\n", len);

	    /*
	     * doch nicht zu frueh gefreut, denn
	     * schon bei der Zuweisung an einen Zeiger
	     * (z.B. fuer die Uebergabe an eine Funktion,
	     * gibt es nur noch die Groesseninfo des Zeigers
	     * und nicht mehr des Arrays :-()
	     */
	printf("sizeof(p) = %d\n", sizeof(p));

	for (i = 0; i <= 5; i++)
		printf("a[%d] = %d\n", i, a[i]);

	    /*
	     * man kann mit dem Zeiger p aber genauso auf
	     * das Array a zugreifen, wie mit a selbst:
	     */
	for (i = 0; i <= 5; i++)
		printf("p[%d] = %d\n", i, p[i]);

	return 0;
}
