#include <stdio.h>

int main() {
	int x = 0x12345678;
	int *p = &x;	/* kein Cast notwendig, da Zeiger-Typ stimmt */

	    /*
	     * zunaechst mal schauen wir an die Speicherstelle von x
	     */
	printf("%08x [bei Adresse %08x]\n", *p, (int) p);
	    /*
	     * ... dann gehen wir eine Integer weiter
	     */
	printf("%08x [bei Adresse %08x]\n", *(p+1), (int) (p+1));
	    /*
	     * ... und eine Integer zurueck
	     * (beachte, dass in diesem Fall sizeof(TYP) = sizeof(int) = 4
	     *  und somit p-1 den Wert von p um 4 dekrementiert; oben analog)
	     */
	printf("%08x [bei Adresse %08x]\n", *(p-1), (int) (p-1));
	/*
	 * Dieser Zugriff erfolgt sicherlich _ausserhalb_ des Speicherbereichs
	 * des aktuellen Prozesses. Deshalb kommt es an dieser Stelle auch
	 * zu einem segmentation fault/violation => core dump
	 */
	printf("%08x [bei Adresse %08x]\n", *(p+10000), (int) (p+10000));

	return 0;
}
