#include <stdio.h>

int main() {
	    /*
	     * Anlegen eines mehrdimensionalen Arrays
	     * mit sofortiger Initialisierung (zeilenweise);
	     * a ist ein 2-dim. Array, dessen Elemente 3-dim.
	     * int-Arrays sind.
	     */
	int a[2][3] = {{1,2,3},{4,5,6}};
	int i, j;

	    /*
	     * a ist konst. Zeiger auf das erste Element (a[0]), also
	     * vom Typ Zeiger auf 3-dim. int-Array
	     */
	printf("Adresse von a = %08x\n", (int) a);

	    /*
	     * "Druchleuchten" der Anordnung der Elemente im Speicher
	     */
	for (i = 0; i < 2; i++)
		for (j = 0; j < 3; j++)
			printf("a[%d][%d] = %d [bei Adresse %08x]\n", i, j, a[i][j], (int) &a[i][j]);

	return 0;
}
